您的位置:首页 > 产品设计 > UI/UE

【LeetCode】357. Count Numbers with Unique Digits

2016-06-14 14:19 309 查看
357. Count Numbers with Unique Digits

Given a non-negative integer n, count all numbers with unique digits, x, where 0 ≤ x < 10n.

Example:

Given n = 2, return 91. (The answer should be the total numbers in the range of 0 ≤ x < 100, excluding [11,22,33,44,55,66,77,88,99])

Hint:

    1. A direct way is to use the backtracking approach.

    2. Backtracking should contains three states which are (the current number, number of steps to get that number and a bitmask which represent which number is marked as visited so far in the current number). Start with state (0,0,0) and count all valid number
till we reach number of steps equals to 10n.

    3. This problem can also be solved using a dynamic programming approach and some knowledge of combinatorics.

    4. Let f(k) = count of numbers with unique digits with length equals k.

    5. f(1) = 10, ..., f(k) = 9 * 9 * 8 * ... (9 - k + 2) [The first factor is 9 because a number cannot start with 0].

Credits:

Special thanks to @memoryless for adding this problem and creating all test cases.

【解题思路】

dp和递归都可以解决。

假设f(k)代表位数为k时所求结果。那么f(1) = 10,f(2) = 9 * 8 (十位可以取1,2,3,4,5,6,7,8,9一共九个数,个位可选择就是8+1 多个0),

以此类推,f(3) = 9 * 9 * 8

f(k) = 9 * 9 * 8 * (11 - k)

dp[k]为所求结果,则dp[k] = f[k] + f[k-1] + ... + f[1]
注意11位时候一定有重复,所以11及以上数字和10一样。

Java AC
public class Solution {
public int countNumbersWithUniqueDigits(int n) {
if(n == 0){
return 1;
}
if(n == 1){
return 10;
}
n = n > 10 ? 10 : n;
int f[] = new int[n + 1];
f[1] = 10;
f[2] = 9 * 9;
for(int i = 3; i < n + 1; i++){
f[i] = f[i - 1] * (11 - i);
}
int dp[] = new int[n + 1];
dp[1] = 10;
for(int i = 2; i < n + 1; i++){
dp[i] = dp[i - 1] + f[i];
}
return dp
;
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: